(*
    This file is part of the Matrix project -
    which currently provides 4x4 matrices.
    
    Copyright (C) 2000 ANOQ of the Sun (alias Johnny Andersen).
    
    E-mail: anoq@HardcoreProcessing.com

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    As a special exception, if you do not do anything which is not in
    the spirit of the GNU Library General Public License, you are not
    required to physically compile this software into a separate library,
    since this is generally not possible with current Stanard ML compilers.
    However if you do something which is not in the spirit of the
    GNU Library General Public License you will have to follow the
    licence perpetually - thus disallowing you to use it for any
    commercial purposes at all.

    If you are interested in a warranty or commercial support for this
    software, contact Hardcore Processing <sales@HardcoreProcessing.com>
    for more information.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the Free
    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*)


signature MATRIX_4X4 =
  sig
    include ADD_SCALE_MULT_ARITH where type scalar = real
    type tuples = Matrix4x4Type.t

    val fromTuples : tuples -> t
    val toTuples : t -> tuples
    val determinant : t -> real
    val transpose : t -> t
    val adjoint : t -> t
  
    structure Const : MATRIX_4X4_COMMON where (*type t = t
                                          and *)type angle = real
    structure Trans : MATRIX_4X4_TRANSFORMATION where type t = t

    sharing type t = Const.t
  end
